{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2014 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnTestToolBarWizard;
{ |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* Ԫƣ༭רʾԪ
* ԪߣCnPack 
*     עõԪǱ༭ⲿĲԵԪ
* ƽ̨PWin2000Pro + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 + C++Builder 5/6
*   ôеַݲֱ֧ػʽ
* Ԫʶ$Id: CnTestToolBarWizard.pas 1385 2013-12-31 15:39:02Z liuxiaoshanzhashu@gmail.com $
* ޸ļ¼2002.11.07 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{$I CnWizards.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolsAPI, IniFiles, StdCtrls,
  CnWizClasses, CnWizUtils, CnWizConsts, CnEditControlWrapper;

type

//==============================================================================
// ༭ò˵ר
//==============================================================================

{ TCnTestToolBarWizard }

  TCnTestToolBarWizard = class(TCnMenuWizard)
  private
    FCombo: TControl;
    FRegistered: Boolean;
  protected
    function GetHasConfig: Boolean; override;
    procedure EditorChanged(Editor: TEditorObject; ChangeType:
      TEditorChangeTypes);
  public
    function GetState: TWizardState; override;
    procedure Config; override;
    procedure LoadSettings(Ini: TCustomIniFile); override;
    procedure SaveSettings(Ini: TCustomIniFile); override;
    class procedure GetWizardInfo(var Name, Author, Email, Comment: string); override;
    function GetCaption: string; override;
    function GetHint: string; override;
    function GetDefShortCut: TShortCut; override;
    procedure Execute; override;

    destructor Destroy; override;

    procedure CreateToolBar(EditControl: TControl; Sender: TObject);
    procedure InitToolBar(EditControl: TControl; Sender: TObject);
  end;

implementation

uses
  CnSrcEditorToolBar;

//==============================================================================
// ༭ò˵ר
//==============================================================================

{ TCnSampleMenuWizard }

procedure TCnTestToolBarWizard.Config;
begin
  ShowMessage('Test option.');
  { TODO -oAnyone : ڴʾô }
end;

procedure TCnTestToolBarWizard.CreateToolBar(EditControl: TControl; Sender: TObject);
begin
  if Sender is TControl then
  begin
    FCombo := TComboBox.Create(Sender as TComponent);
    FCombo.Parent := Sender as TWinControl;

    (Sender as TControl).Top := 50;
  end;  
end;

destructor TCnTestToolBarWizard.Destroy;
begin
  if FRegistered then
    EditControlWrapper.RemoveEditorChangeNotifier(EditorChanged);
  inherited;
end;

procedure TCnTestToolBarWizard.EditorChanged(Editor: TEditorObject;
  ChangeType: TEditorChangeTypes);
var
  S: string;
begin
  if ChangeType * [ctView, ctWindow, ctCurrLine, ctCurrCol, ctModified] <> [] then
  begin
    S := CnOtaGetCurrentProcedure;
    if S = '' then
      S := CnOtaGetCurrentOuterBlock;

    if FCombo <> nil then
      (FCombo as TComboBox).Text := S;
  end;
end;

procedure TCnTestToolBarWizard.Execute;
begin
  if CnEditorToolBarService <> nil then
  begin
    CnEditorToolBarService.RegisterToolBarType('TestToolBar', CreateToolBar, InitToolBar, nil);
    EditControlWrapper.AddEditorChangeNotifier(EditorChanged);
    FRegistered := True;
  end;
  { TODO -oAnyone : רҵִй }
end;

function TCnTestToolBarWizard.GetCaption: string;
begin
  Result := 'Register a ToolBar Type';
  { TODO -oAnyone : רҲ˵ı⣬ַбػ }
end;

function TCnTestToolBarWizard.GetDefShortCut: TShortCut;
begin
  Result := 0;
  { TODO -oAnyone : ĬϵĿݼ }
end;

function TCnTestToolBarWizard.GetHasConfig: Boolean;
begin
  Result := False;
  { TODO -oAnyone : רǷô }
end;

function TCnTestToolBarWizard.GetHint: string;
begin
  Result := 'Register an Editor ToolBar Type';
  { TODO -oAnyone : רҲ˵ʾϢַбػ }
end;

function TCnTestToolBarWizard.GetState: TWizardState;
begin
  Result := [wsEnabled];
  { TODO -oAnyone : רҲ˵״̬ɸָ趨 }
end;

class procedure TCnTestToolBarWizard.GetWizardInfo(var Name, Author, Email, Comment: string);
begin
  Name := 'TestEditorToolBarWizard';
  Author := 'CnPack Team';
  Email := 'master@cnpack.org';
  Comment := 'Test Editor ToolBar Wizard';
  { TODO -oAnyone : רҵơߡ估עַбػ }
end;

procedure TCnTestToolBarWizard.InitToolBar(EditControl: TControl; Sender: TObject);
begin
  (FCombo as TComboBox).Items.Add('Test1');
  (FCombo as TComboBox).Items.Add('Test2');
end;

procedure TCnTestToolBarWizard.LoadSettings(Ini: TCustomIniFile);
begin
  { TODO -oAnyone : ڴװרڲõĲרҴʱԶ }
end;

procedure TCnTestToolBarWizard.SaveSettings(Ini: TCustomIniFile);
begin
  { TODO -oAnyone : ڴ˱רڲõĲרͷʱԶ }
end;

initialization
  RegisterCnWizard(TCnTestToolBarWizard); // ער

end.
